
	.include	'jaguar.inc'

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	.extern VideoIni
	.extern IntInit
	.extern Lister
	.extern	set_stopobj
	.extern save_list
	.extern BlitLine
	.extern Clear
	.extern	qdemo

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	.text

; Run the GPU/BLIT interface in CORRECT mode ALWAYS

	move.l	#$00070007,G_END
	move.l	#$00070007,D_END	; Set GOOD mode for DSP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; At this point we don't know what state the video is in
; It may be active or not and may be using an interrupt or not
; Since we may not turn video off we use the following procedure
;
; 1) Disable all 68K interrupts, this includes VI.
;    The existing screen will fail to be refreshed so all bit maps vanish
; 2) Set up the size of borders
; 3) Set up an object list
; 4) Set VMODE to the desired resolution and color model
; 5) Set up an interrupt and start
;
; NOTE: Steps 2, 3 and 4 may be done in any order. If the gap between
; steps 1 and 5 is too long the screen may look funny. To blank the screen
; point the object processor at a stop object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	move.w	#$FFFF,VI	; Disable all 68K interrupts, including VI
	move.l	#INITSTACK,a7	; Put the stack at the top of DRAM
	jsr	set_stopobj	; Point OLP at stop object
	jsr	VideoIni	; Set up our video (borders, etc.)
	jsr	Lister		; Set up object list
	jsr	save_list	; Save a copy of fields which need refreshing
	jsr	IntInit		; Initialize and enable vblank interrupt
	jsr	Clear		; Clear our bitmap

	move.l	d5,OLP		; Aim Object processor at list setup by Lister
	move.w	#$6C7,VMODE	; Set 16 bit RGB; 320 overscanned

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	jsr	qdemo		; Call our main program function
	illegal			; crash if exit main function
